diff -r -uw -N irrlicht/source/Irrlicht/CD3D9MaterialRenderer.h irrlicht_multipatch/source/Irrlicht/CD3D9MaterialRenderer.h
--- irrlicht/source/Irrlicht/CD3D9MaterialRenderer.h	2006-11-01 08:01:46.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CD3D9MaterialRenderer.h	2006-11-30 18:35:48.000000000 +0100
@@ -18,22 +18,35 @@
 namespace video
 {
 
-D3DMATRIX UnitMatrixD3D9;
-D3DMATRIX SphereMapMatrixD3D9;
-
 //! Base class for all internal D3D9 material renderers
 class CD3D9MaterialRenderer : public IMaterialRenderer
 {
 public:
 
 	//! Constructor
-	CD3D9MaterialRenderer(IDirect3DDevice9* d3ddev, video::IVideoDriver* driver)
-		: pID3DDevice(d3ddev), Driver(driver)
+	CD3D9MaterialRenderer(core::array<IDirect3DDevice9*> d3ddev, video::IVideoDriver* driver)
+		: Driver(driver)
 	{
+		for(u32 idx = 0; idx < d3ddev.size(); ++idx)
+			pID3DDevices.push_back(d3ddev[idx]);
+
+		core::matrix4 mat;
+		m_UnitMatrixD3D9 = *(D3DMATRIX*)((void*)&mat);
+
+		m_SphereMapMatrixD3D9._11 = 0.5f; m_SphereMapMatrixD3D9._12 = 0.0f; 
+		m_SphereMapMatrixD3D9._13 = 0.0f; m_SphereMapMatrixD3D9._14 = 0.0f; 
+		m_SphereMapMatrixD3D9._21 = 0.0f; m_SphereMapMatrixD3D9._22 =-0.5f;
+		m_SphereMapMatrixD3D9._23 = 0.0f; m_SphereMapMatrixD3D9._24 = 0.0f; 
+		m_SphereMapMatrixD3D9._31 = 0.0f; m_SphereMapMatrixD3D9._32 = 0.0f;
+		m_SphereMapMatrixD3D9._33 = 1.0f; m_SphereMapMatrixD3D9._34 = 0.0f; 
+		m_SphereMapMatrixD3D9._41 = 0.5f; m_SphereMapMatrixD3D9._42 = 0.5f; 
+		m_SphereMapMatrixD3D9._43 = 0.0f; m_SphereMapMatrixD3D9._44 = 1.0f; 
+		deviceIndex = 0;
 	}
 
 	~CD3D9MaterialRenderer()
 	{
+		pID3DDevices.clear();
 	}
 
 	//! sets a variable in the shader.
@@ -50,8 +63,11 @@
 
 protected:
 
-	IDirect3DDevice9* pID3DDevice;
+	core::array<IDirect3DDevice9*> pID3DDevices;
 	video::IVideoDriver* Driver;
+	D3DMATRIX m_UnitMatrixD3D9;
+	D3DMATRIX m_SphereMapMatrixD3D9;
+
 };
 
 
@@ -60,7 +76,7 @@
 {
 public:
 
-	CD3D9MaterialRenderer_SOLID(IDirect3DDevice9* p, video::IVideoDriver* d)
+	CD3D9MaterialRenderer_SOLID(core::array<IDirect3DDevice9*> p, video::IVideoDriver* d)
 		: CD3D9MaterialRenderer(p, d) {}
 
 	virtual void OnSetMaterial(SMaterial& material, const SMaterial& lastMaterial,
@@ -68,14 +84,14 @@
 	{
 		if (material.MaterialType != lastMaterial.MaterialType || resetAllRenderstates)
 		{
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLOROP, D3DTOP_MODULATE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLOROP, D3DTOP_MODULATE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
 		}
 
-		pID3DDevice->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_DISABLE);
-		pID3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
+		pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_DISABLE);
+		pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
 
 		services->setBasicRenderStates(material, lastMaterial, resetAllRenderstates);
 	}
@@ -87,7 +103,7 @@
 {
 public:
 
-	CD3D9MaterialRenderer_SOLID_2_LAYER(IDirect3DDevice9* p, video::IVideoDriver* d)
+	CD3D9MaterialRenderer_SOLID_2_LAYER(core::array<IDirect3DDevice9*> p, video::IVideoDriver* d)
 		: CD3D9MaterialRenderer(p, d) {}
 
 	virtual void OnSetMaterial(SMaterial& material, const SMaterial& lastMaterial,
@@ -95,14 +111,14 @@
 	{
 		if (material.MaterialType != lastMaterial.MaterialType || resetAllRenderstates)
 		{
-			pID3DDevice->SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_SELECTARG1);
-			pID3DDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
-			pID3DDevice->SetTextureStageState(0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
+			pID3DDevices[deviceIndex]->SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_SELECTARG1);
+			pID3DDevices[deviceIndex]->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
+			pID3DDevices[deviceIndex]->SetTextureStageState(0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
 
-			pID3DDevice->SetTextureStageState(1, D3DTSS_TEXCOORDINDEX, 0);
-			pID3DDevice->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_BLENDDIFFUSEALPHA);
+			pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_TEXCOORDINDEX, 0);
+			pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_BLENDDIFFUSEALPHA);
 
-			pID3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
 		}
 
 		services->setBasicRenderStates(material, lastMaterial, resetAllRenderstates);
@@ -115,7 +131,7 @@
 {
 public:
 
-	CD3D9MaterialRenderer_TRANSPARENT_ADD_COLOR(IDirect3DDevice9* p, video::IVideoDriver* d)
+	CD3D9MaterialRenderer_TRANSPARENT_ADD_COLOR(core::array<IDirect3DDevice9*> p, video::IVideoDriver* d)
 		: CD3D9MaterialRenderer(p, d) {}
 
 	virtual void OnSetMaterial(SMaterial& material, const SMaterial& lastMaterial,
@@ -123,15 +139,15 @@
 	{
 		if (material.MaterialType != lastMaterial.MaterialType || resetAllRenderstates)
 		{
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLOROP, D3DTOP_MODULATE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
-
-			pID3DDevice->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_DISABLE);
-			pID3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
-			pID3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_ONE);
-			pID3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCCOLOR);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLOROP, D3DTOP_MODULATE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
+
+			pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_DISABLE);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_ONE);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCCOLOR);
 		}
 
 		material.ZWriteEnable = false;
@@ -152,7 +168,7 @@
 {
 public:
 
-	CD3D9MaterialRenderer_TRANSPARENT_VERTEX_ALPHA(IDirect3DDevice9* p, video::IVideoDriver* d)
+	CD3D9MaterialRenderer_TRANSPARENT_VERTEX_ALPHA(core::array<IDirect3DDevice9*> p, video::IVideoDriver* d)
 		: CD3D9MaterialRenderer(p, d) {}
 
 	virtual void OnSetMaterial(SMaterial& material, const SMaterial& lastMaterial,
@@ -160,18 +176,18 @@
 	{
 		if (material.MaterialType != lastMaterial.MaterialType || resetAllRenderstates)
 		{
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLOROP, D3DTOP_MODULATE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_ALPHAOP,  D3DTOP_SELECTARG1);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_ALPHAARG1,  D3DTA_DIFFUSE);
-
-			pID3DDevice->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_DISABLE);
-			pID3DDevice->SetTextureStageState(1, D3DTSS_ALPHAOP, D3DTOP_DISABLE);
-
-			pID3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
-			pID3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_ONE);
-			pID3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLOROP, D3DTOP_MODULATE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_ALPHAOP,  D3DTOP_SELECTARG1);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_ALPHAARG1,  D3DTA_DIFFUSE);
+
+			pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_DISABLE);
+			pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_ALPHAOP, D3DTOP_DISABLE);
+
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_ONE);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
 		}
 
 		material.ZWriteEnable = false;
@@ -192,7 +208,7 @@
 {
 public:
 
-	CD3D9MaterialRenderer_TRANSPARENT_ALPHA_CHANNEL(IDirect3DDevice9* p, video::IVideoDriver* d)
+	CD3D9MaterialRenderer_TRANSPARENT_ALPHA_CHANNEL(core::array<IDirect3DDevice9*> p, video::IVideoDriver* d)
 		: CD3D9MaterialRenderer(p, d) {}
 
 	virtual void OnSetMaterial(SMaterial& material, const SMaterial& lastMaterial,
@@ -201,26 +217,26 @@
 		if (material.MaterialType != lastMaterial.MaterialType || resetAllRenderstates
 			|| material.MaterialTypeParam != lastMaterial.MaterialTypeParam )
 		{
-			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
-			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
-			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_CURRENT );
-			pID3DDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1 );
-			pID3DDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
-
-			pID3DDevice->SetTextureStageState( 1, D3DTSS_COLOROP,   D3DTOP_DISABLE );
-			pID3DDevice->SetTextureStageState( 1, D3DTSS_ALPHAOP,   D3DTOP_DISABLE );
-
-			pID3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
-			pID3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
-			pID3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
+			pID3DDevices[deviceIndex]->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
+			pID3DDevices[deviceIndex]->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
+			pID3DDevices[deviceIndex]->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_CURRENT );
+			pID3DDevices[deviceIndex]->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1 );
+			pID3DDevices[deviceIndex]->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
+
+			pID3DDevices[deviceIndex]->SetTextureStageState( 1, D3DTSS_COLOROP,   D3DTOP_DISABLE );
+			pID3DDevices[deviceIndex]->SetTextureStageState( 1, D3DTSS_ALPHAOP,   D3DTOP_DISABLE );
+
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
 
 			s32 refValue = (s32)(material.MaterialTypeParam * 255);
 			if ( !refValue )
 				refValue = 127; // default value
 
-			pID3DDevice->SetRenderState(D3DRS_ALPHAREF, refValue);
-			pID3DDevice->SetRenderState(D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL);
-			pID3DDevice->SetRenderState(D3DRS_ALPHATESTENABLE, TRUE);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHAREF, refValue);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHATESTENABLE, TRUE);
 		}
 
 		//material.ZWriteEnable = false;
@@ -229,7 +245,7 @@
 
 	virtual void OnUnsetMaterial()
 	{
-		pID3DDevice->SetRenderState(D3DRS_ALPHATESTENABLE, FALSE);
+		pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHATESTENABLE, FALSE);
 	}
 
 	//! Returns if the material is transparent. The scene managment needs to know this
@@ -247,7 +263,7 @@
 {
 public:
 
-	CD3D9MaterialRenderer_TRANSPARENT_ALPHA_CHANNEL_REF(IDirect3DDevice9* p, video::IVideoDriver* d)
+	CD3D9MaterialRenderer_TRANSPARENT_ALPHA_CHANNEL_REF(core::array<IDirect3DDevice9*> p, video::IVideoDriver* d)
 		: CD3D9MaterialRenderer(p, d) {}
 
 	virtual void OnSetMaterial(SMaterial& material, const SMaterial& lastMaterial,
@@ -255,20 +271,20 @@
 	{
 		if (material.MaterialType != lastMaterial.MaterialType || resetAllRenderstates)
 		{
-			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
-			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
-			pID3DDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_CURRENT );
-			pID3DDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1 );
-			pID3DDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
-
-			pID3DDevice->SetTextureStageState( 1, D3DTSS_COLOROP,   D3DTOP_DISABLE );
-			pID3DDevice->SetTextureStageState( 1, D3DTSS_ALPHAOP,   D3DTOP_DISABLE );
-
-			pID3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
-
-			pID3DDevice->SetRenderState(D3DRS_ALPHAREF,127);
-			pID3DDevice->SetRenderState(D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL);
-			pID3DDevice->SetRenderState(D3DRS_ALPHATESTENABLE, TRUE);
+			pID3DDevices[deviceIndex]->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
+			pID3DDevices[deviceIndex]->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
+			pID3DDevices[deviceIndex]->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_CURRENT );
+			pID3DDevices[deviceIndex]->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1 );
+			pID3DDevices[deviceIndex]->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
+
+			pID3DDevices[deviceIndex]->SetTextureStageState( 1, D3DTSS_COLOROP,   D3DTOP_DISABLE );
+			pID3DDevices[deviceIndex]->SetTextureStageState( 1, D3DTSS_ALPHAOP,   D3DTOP_DISABLE );
+
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
+
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHAREF,127);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHATESTENABLE, TRUE);
 		}
 
 		services->setBasicRenderStates(material, lastMaterial, resetAllRenderstates);
@@ -276,7 +292,7 @@
 
 	virtual void OnUnsetMaterial()
 	{
-		pID3DDevice->SetRenderState(D3DRS_ALPHATESTENABLE, FALSE);
+		pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHATESTENABLE, FALSE);
 	}
 
 	//! Returns if the material is transparent. The scene managment needs to know this
@@ -293,7 +309,7 @@
 {
 public:
 
-	CD3D9MaterialRenderer_LIGHTMAP(IDirect3DDevice9* p, video::IVideoDriver* d)
+	CD3D9MaterialRenderer_LIGHTMAP(core::array<IDirect3DDevice9*> p, video::IVideoDriver* d)
 		: CD3D9MaterialRenderer(p, d) {}
 
 	virtual void OnSetMaterial(SMaterial& material, const SMaterial& lastMaterial,
@@ -304,35 +320,35 @@
 			if (material.MaterialType >= EMT_LIGHTMAP_LIGHTING)
 			{
 				// with lighting
-				pID3DDevice->SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE);
-				pID3DDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
-				pID3DDevice->SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
+				pID3DDevices[deviceIndex]->SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE);
+				pID3DDevices[deviceIndex]->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
+				pID3DDevices[deviceIndex]->SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
 			}
 			else
 			{
-				pID3DDevice->SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_SELECTARG1);
-				pID3DDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
+				pID3DDevices[deviceIndex]->SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_SELECTARG1);
+				pID3DDevices[deviceIndex]->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
 			}
 
-			pID3DDevice->SetTextureStageState(0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
-			pID3DDevice->SetTextureStageState(1, D3DTSS_TEXCOORDINDEX, 1);
+			pID3DDevices[deviceIndex]->SetTextureStageState(0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
+			pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_TEXCOORDINDEX, 1);
 
 			if (material.MaterialType == EMT_LIGHTMAP_ADD)
-				pID3DDevice->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_ADD);
+				pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_ADD);
 			else
 			if (material.MaterialType == EMT_LIGHTMAP_M4)
-				pID3DDevice->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_MODULATE4X);
+				pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_MODULATE4X);
 			else
 			if (material.MaterialType == EMT_LIGHTMAP_M2)
-				pID3DDevice->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_MODULATE2X);
+				pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_MODULATE2X);
 			else
-				pID3DDevice->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_MODULATE);
+				pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_MODULATE);
 
-			pID3DDevice->SetTextureStageState(1, D3DTSS_COLORARG1, D3DTA_TEXTURE);
-			pID3DDevice->SetTextureStageState(1, D3DTSS_COLORARG2, D3DTA_CURRENT);
-			pID3DDevice->SetTextureStageState (1, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
+			pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_COLORARG1, D3DTA_TEXTURE);
+			pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_COLORARG2, D3DTA_CURRENT);
+			pID3DDevices[deviceIndex]->SetTextureStageState (1, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
 
-			pID3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
 		}
 
 		services->setBasicRenderStates(material, lastMaterial, resetAllRenderstates);
@@ -346,7 +362,7 @@
 {
 public:
 
-	CD3D9MaterialRenderer_DETAIL_MAP(IDirect3DDevice9* p, video::IVideoDriver* d)
+	CD3D9MaterialRenderer_DETAIL_MAP(core::array<IDirect3DDevice9*> p, video::IVideoDriver* d)
 		: CD3D9MaterialRenderer(p, d) {}
 
 	virtual void OnSetMaterial(SMaterial& material, const SMaterial& lastMaterial,
@@ -354,18 +370,18 @@
 	{
 		if (material.MaterialType != lastMaterial.MaterialType || resetAllRenderstates)
 		{
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLOROP, D3DTOP_MODULATE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
-
-			pID3DDevice->SetTextureStageState (1, D3DTSS_COLOROP, D3DTOP_ADDSIGNED);
-			pID3DDevice->SetTextureStageState (1, D3DTSS_COLORARG1, D3DTA_TEXTURE);
-			pID3DDevice->SetTextureStageState (1, D3DTSS_COLORARG2, D3DTA_CURRENT);
-			pID3DDevice->SetTextureStageState (1, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLOROP, D3DTOP_MODULATE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
+
+			pID3DDevices[deviceIndex]->SetTextureStageState (1, D3DTSS_COLOROP, D3DTOP_ADDSIGNED);
+			pID3DDevices[deviceIndex]->SetTextureStageState (1, D3DTSS_COLORARG1, D3DTA_TEXTURE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (1, D3DTSS_COLORARG2, D3DTA_CURRENT);
+			pID3DDevices[deviceIndex]->SetTextureStageState (1, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
 
-			pID3DDevice->SetTextureStageState(1, D3DTSS_TEXCOORDINDEX, 1);
-			pID3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
+			pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_TEXCOORDINDEX, 1);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
 		}
 
 		services->setBasicRenderStates(material, lastMaterial, resetAllRenderstates);
@@ -378,7 +394,7 @@
 {
 public:
 
-	CD3D9MaterialRenderer_SPHERE_MAP(IDirect3DDevice9* p, video::IVideoDriver* d)
+	CD3D9MaterialRenderer_SPHERE_MAP(core::array<IDirect3DDevice9*> p, video::IVideoDriver* d)
 		: CD3D9MaterialRenderer(p, d) {}
 
 	virtual void OnSetMaterial(SMaterial& material, const SMaterial& lastMaterial,
@@ -386,17 +402,17 @@
 	{
 		if (material.MaterialType != lastMaterial.MaterialType || resetAllRenderstates)
 		{
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLOROP, D3DTOP_MODULATE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
-
-			pID3DDevice->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_DISABLE);
-			pID3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
-
-			pID3DDevice->SetTransform( D3DTS_TEXTURE0, &SphereMapMatrixD3D9 );
-			pID3DDevice->SetTextureStageState( 0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT2 );
-			pID3DDevice->SetTextureStageState( 0, D3DTSS_TEXCOORDINDEX, D3DTSS_TCI_CAMERASPACENORMAL );
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLOROP, D3DTOP_MODULATE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
+
+			pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_DISABLE);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
+
+			pID3DDevices[deviceIndex]->SetTransform( D3DTS_TEXTURE0, &m_SphereMapMatrixD3D9 );
+			pID3DDevices[deviceIndex]->SetTextureStageState( 0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT2 );
+			pID3DDevices[deviceIndex]->SetTextureStageState( 0, D3DTSS_TEXCOORDINDEX, D3DTSS_TCI_CAMERASPACENORMAL );
 		}
 
 		services->setBasicRenderStates(material, lastMaterial, resetAllRenderstates);
@@ -404,9 +420,9 @@
 
 	virtual void OnUnsetMaterial()
 	{
-		pID3DDevice->SetTextureStageState( 0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_DISABLE );
-		pID3DDevice->SetTextureStageState( 0, D3DTSS_TEXCOORDINDEX, 0);
-		pID3DDevice->SetTransform( D3DTS_TEXTURE0, &UnitMatrixD3D9 );
+		pID3DDevices[deviceIndex]->SetTextureStageState( 0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_DISABLE );
+		pID3DDevices[deviceIndex]->SetTextureStageState( 0, D3DTSS_TEXCOORDINDEX, 0);
+		pID3DDevices[deviceIndex]->SetTransform( D3DTS_TEXTURE0, &m_UnitMatrixD3D9 );
 	}
 };
 
@@ -416,7 +432,7 @@
 {
 public:
 
-	CD3D9MaterialRenderer_REFLECTION_2_LAYER(IDirect3DDevice9* p, video::IVideoDriver* d)
+	CD3D9MaterialRenderer_REFLECTION_2_LAYER(core::array<IDirect3DDevice9*> p, video::IVideoDriver* d)
 		: CD3D9MaterialRenderer(p, d) {}
 
 	virtual void OnSetMaterial(SMaterial& material, const SMaterial& lastMaterial,
@@ -424,19 +440,19 @@
 	{
 		if (material.MaterialType != lastMaterial.MaterialType || resetAllRenderstates)
 		{
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLOROP, D3DTOP_MODULATE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
-
-			pID3DDevice->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_MODULATE);
-			pID3DDevice->SetTextureStageState(1, D3DTSS_COLORARG1, D3DTA_TEXTURE);
-			pID3DDevice->SetTextureStageState(1, D3DTSS_COLORARG2, D3DTA_CURRENT);
-
-			pID3DDevice->SetTransform( D3DTS_TEXTURE1, &SphereMapMatrixD3D9 );
-			pID3DDevice->SetTextureStageState( 1, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT2 );
-			pID3DDevice->SetTextureStageState( 1, D3DTSS_TEXCOORDINDEX, D3DTSS_TCI_CAMERASPACEREFLECTIONVECTOR);
-			pID3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLOROP, D3DTOP_MODULATE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
+
+			pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_MODULATE);
+			pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_COLORARG1, D3DTA_TEXTURE);
+			pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_COLORARG2, D3DTA_CURRENT);
+
+			pID3DDevices[deviceIndex]->SetTransform( D3DTS_TEXTURE1, &m_SphereMapMatrixD3D9 );
+			pID3DDevices[deviceIndex]->SetTextureStageState( 1, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT2 );
+			pID3DDevices[deviceIndex]->SetTextureStageState( 1, D3DTSS_TEXCOORDINDEX, D3DTSS_TCI_CAMERASPACEREFLECTIONVECTOR);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
 		}
 
 		services->setBasicRenderStates(material, lastMaterial, resetAllRenderstates);
@@ -444,9 +460,9 @@
 
 	virtual void OnUnsetMaterial()
 	{
-		pID3DDevice->SetTextureStageState( 1, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_DISABLE );
-		pID3DDevice->SetTextureStageState( 1, D3DTSS_TEXCOORDINDEX, 1);
-		pID3DDevice->SetTransform( D3DTS_TEXTURE1, &UnitMatrixD3D9 );
+		pID3DDevices[deviceIndex]->SetTextureStageState( 1, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_DISABLE );
+		pID3DDevices[deviceIndex]->SetTextureStageState( 1, D3DTSS_TEXCOORDINDEX, 1);
+		pID3DDevices[deviceIndex]->SetTransform( D3DTS_TEXTURE1, &m_UnitMatrixD3D9 );
 	}
 };
 
@@ -456,7 +472,7 @@
 {
 public:
 
-	CD3D9MaterialRenderer_TRANSPARENT_REFLECTION_2_LAYER(IDirect3DDevice9* p, video::IVideoDriver* d)
+	CD3D9MaterialRenderer_TRANSPARENT_REFLECTION_2_LAYER(core::array<IDirect3DDevice9*> p, video::IVideoDriver* d)
 		: CD3D9MaterialRenderer(p, d) {}
 
 	virtual void OnSetMaterial(SMaterial& material, const SMaterial& lastMaterial,
@@ -464,23 +480,23 @@
 	{
 		if (material.MaterialType != lastMaterial.MaterialType || resetAllRenderstates)
 		{
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLOROP, D3DTOP_MODULATE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
-			pID3DDevice->SetTextureStageState (0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
-
-			pID3DDevice->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_MODULATE);
-			pID3DDevice->SetTextureStageState(1, D3DTSS_COLORARG1, D3DTA_TEXTURE);
-			pID3DDevice->SetTextureStageState(1, D3DTSS_COLORARG2, D3DTA_CURRENT);
-
-			pID3DDevice->SetTransform( D3DTS_TEXTURE1, &SphereMapMatrixD3D9 );
-			pID3DDevice->SetTextureStageState( 1, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT2 );
-			pID3DDevice->SetTextureStageState( 1, D3DTSS_TEXCOORDINDEX, D3DTSS_TCI_CAMERASPACEREFLECTIONVECTOR);
-			pID3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
-
-			pID3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
-			pID3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
-			pID3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLOROP, D3DTOP_MODULATE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);
+			pID3DDevices[deviceIndex]->SetTextureStageState (0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE);
+
+			pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_MODULATE);
+			pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_COLORARG1, D3DTA_TEXTURE);
+			pID3DDevices[deviceIndex]->SetTextureStageState(1, D3DTSS_COLORARG2, D3DTA_CURRENT);
+
+			pID3DDevices[deviceIndex]->SetTransform( D3DTS_TEXTURE1, &m_SphereMapMatrixD3D9 );
+			pID3DDevices[deviceIndex]->SetTextureStageState( 1, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT2 );
+			pID3DDevices[deviceIndex]->SetTextureStageState( 1, D3DTSS_TEXCOORDINDEX, D3DTSS_TCI_CAMERASPACEREFLECTIONVECTOR);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
+
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
+			pID3DDevices[deviceIndex]->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
 		}
 
 		material.ZWriteEnable = false;
@@ -489,9 +505,9 @@
 
 	virtual void OnUnsetMaterial()
 	{
-		pID3DDevice->SetTextureStageState( 1, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_DISABLE );
-		pID3DDevice->SetTextureStageState( 1, D3DTSS_TEXCOORDINDEX, 1);
-		pID3DDevice->SetTransform( D3DTS_TEXTURE1, &UnitMatrixD3D9 );
+		pID3DDevices[deviceIndex]->SetTextureStageState( 1, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_DISABLE );
+		pID3DDevices[deviceIndex]->SetTextureStageState( 1, D3DTSS_TEXCOORDINDEX, 1);
+		pID3DDevices[deviceIndex]->SetTransform( D3DTS_TEXTURE1, &m_UnitMatrixD3D9 );
 	}
 
 	//! Returns if the material is transparent. The scene managment needs to know this
diff -r -uw -N irrlicht/source/Irrlicht/CD3D9NormalMapRenderer.cpp irrlicht_multipatch/source/Irrlicht/CD3D9NormalMapRenderer.cpp
--- irrlicht/source/Irrlicht/CD3D9NormalMapRenderer.cpp	2006-10-15 08:48:46.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CD3D9NormalMapRenderer.cpp	2006-12-05 12:19:43.000000000 +0100
@@ -109,7 +109,7 @@
 		"";
 
 	CD3D9NormalMapRenderer::CD3D9NormalMapRenderer(
-		IDirect3DDevice9* d3ddev, video::IVideoDriver* driver, 
+		core::array<IDirect3DDevice9*> d3ddev, video::IVideoDriver* driver, 
 		s32& outMaterialTypeNr, IMaterialRenderer* baseMaterial)
 		: CD3D9ShaderMaterialRenderer(d3ddev, driver, 0, baseMaterial)
 	{
@@ -120,7 +120,6 @@
 
 		// basicly, this thing simply compiles these hardcoded shaders if the
 		// hardware is able to do them, otherwise it maps to the base material
-
 		if (!driver->queryFeature(video::EVDF_PIXEL_SHADER_1_1) ||
 			!driver->queryFeature(video::EVDF_VERTEX_SHADER_1_1))
 		{
@@ -135,16 +134,21 @@
 		video::IMaterialRenderer* renderer = driver->getMaterialRenderer(EMT_NORMAL_MAP_SOLID);
 		if (renderer)
 		{
+			u32 idx = 0;
 			// use the already compiled shaders 
 			video::CD3D9NormalMapRenderer* nmr = (video::CD3D9NormalMapRenderer*)renderer;
-			VertexShader = nmr->VertexShader;
-			if (VertexShader)
-				VertexShader->AddRef();
-
-			PixelShader = nmr->PixelShader;
-			if (PixelShader)
-				PixelShader->AddRef();
-
+			for(idx = 0; idx < nmr->VertexShaders.size(); ++idx)
+			{
+				VertexShaders[idx] = nmr->VertexShaders[idx];
+				if (VertexShaders[idx])
+					VertexShaders[idx]->AddRef();
+			}
+			for(idx = 0; idx < nmr->PixelShaders.size(); ++idx)
+			{
+				PixelShaders[idx] = nmr->PixelShaders[idx];
+				if (PixelShaders[idx])
+					PixelShaders[idx]->AddRef();
+			}
 			outMaterialTypeNr = driver->addMaterialRenderer(this);
 		}
 		else
diff -r -uw -N irrlicht/source/Irrlicht/CD3D9NormalMapRenderer.h irrlicht_multipatch/source/Irrlicht/CD3D9NormalMapRenderer.h
--- irrlicht/source/Irrlicht/CD3D9NormalMapRenderer.h	2006-06-17 08:11:38.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CD3D9NormalMapRenderer.h	2006-11-30 18:42:58.000000000 +0100
@@ -26,7 +26,7 @@
 public:
 
 	CD3D9NormalMapRenderer(
-		IDirect3DDevice9* d3ddev, video::IVideoDriver* driver, 
+		core::array<IDirect3DDevice9*> d3ddev, video::IVideoDriver* driver, 
 		s32& outMaterialTypeNr, IMaterialRenderer* baseMaterial);
 
 	~CD3D9NormalMapRenderer();
